[intrepid] keyboard Repeat Keys is failing to adjust

Bug #264196 reported by Daniel Hollocher on 2008-09-03
144
This bug affects 17 people
Affects Status Importance Assigned to Milestone
X.Org X server
Fix Released
Medium
xserver-xorg-input-evdev (Ubuntu)
Undecided
Unassigned
Nominated for Intrepid by Daniel Serpell

Bug Description

Welcome. This bug was introduced with the new Xorg in the 8.10 (Intrepid Ibex) release of Ubuntu. It had 2 effects: the default keyboard repeat rate was unusably high, and there was no obvious way to change the repeat rate. There were a few hacks which could effect at least partial fixes, the discussion of which you will find below.

The bug has been fixed upstream, and, in theory, will be included in the 9.10 (Karma Koala) release of Ubuntu. The fix has also been backported to the 9.04 (Jaunty Jackalope) release of Ubuntu. It does not seem like the fix will be backported to 8.10 (Intrepid).

Thus, those affected by this bug should install 9.04.
Q.E.D.
(If there are any continued difficulties, please file a new bug report.)

================== Old bug report ==================
go to System > Preferences > Keyboard > General

The controls under Repeat Keys are failing to properly adjust the timing of how fast keys are repeated when held down.

I filed under gnome, but a person there thinks its an xorg bug in ubuntu: http://bugzilla.gnome.org show_bug.cgi?id=550242 It has become quite clear that this is a problem with the xorg-evdev driver, and intrepids new hotplug architecture.

Here is a workaround for this:

Temporarily add the following to your xorg.conf:
Section "ServerFlags"
Option "AutoAddDevices" "off"
EndSection

Restart X, and you will be able to change the settings. Once changed, you can remove those lines from your xorg.conf (which is recommended since setting AutoAddDevices to off can interfere with your keyboard)

Another (and possibly better) workaround is to set the repeat rate manually, see this comment for directions: https://bugs.launchpad.net/ubuntu/+source/xserver-xorg-input-evdev/+bug/264196/comments/26

This bug may also be related to bug 278078

description: updated

When holding a key down keyboard repeat starts with softrepeat delay/rate settings and is interrupted temporarily when the kernel autorepeat delay/rate would have caused a character to be repeated if the kernel autorepeat would be used.

It's easiest to demonstrate the problem when setting "xset r rate 175 100; kbdrate -r 2 -d 1000" (incidentally also the settings that least disturb softrepeat). So when holding a key down the 175ms delay and 100/sec repeat rate works perfectly for 1000ms (exactly when the kernel repeat delay kicks in), then there's a shot interruption and the 100/sec rate is again continued and again interrupted, but this time after about 500ms (basically at 2/sec, which is the kernel repeate rate).

With default kbdrate settings (those set by xset itself, delay 250ms and 10.9 cps), the problem is even more annoying because the fast softrepeat rate only lasts for 250ms and then slows down to a very slow rate probably dictated by the 10.9 cps. So basically after the kernel repeat delay only the really slow kernel repeat rate applies as softrepeat seems to get no chance of doing anything between the short interruptions caused by the kernel autorepeat.

This is all with xorg-server 1.5.0, kernel 2.6.25, evdev 2.0.4.

I don't remember this problem to have existed with the kbd driver and unfortunately I'm no longer able to get the kbd driver to work (I think it gets confused by the event device which hal is providing and I'm not sure what to do about it).

Thank you,

Timo Aaltonen (tjaalton) wrote :

Looks like the evdev driver doesn't support it, not yet anyway.

Chow Loong Jin (hyperair) wrote :

I found a workaround for this, which is to disable the AutoAddDevices server flag.

In xorg.conf,
Section "ServerFlags"
Option "AutoAddDevices" "off"
EndSection

Daniel Hollocher (chogydan) wrote :

hyperair's workaround worked for me.

Changed in xserver-xorg-input-evdev:
status: New → Confirmed
jbg7474 (jbg7474) wrote :

Are there any side effects to this workaround? It sounds like is disabling something that might be useful.

Thiago Teixeira (tvst) wrote :

I had the same problem and the workaround also worked for me. But, like jbg7474, I'm also wondering what the "AutoAddDevices" option is disabling.

I'm on a Lenovo Thinkpad T60.

jbg7474 (jbg7474) wrote :

Discovered that "xinput list" is a lot smaller than it was before this workaround. But the only issue I've seen thus far is the loss of the horizontal scroll on my mouse. I think this workaround defeats some of the new hal/fdi stuff in Intrepid (but maybe that's a good thing?).

Daniel Hollocher (chogydan) wrote :

I did some searching. It looks like that option turns off intrepid fancy new fangled keyboard and mouse driver. So, all the problems you would experience would regard either missing or incorrect functionality of your keyboard or mouse.

wolfwitch (wolf-mylunarden) wrote :

"Me Too" post! I'm going to try the work-around. This is really-really-really annoying. I thought I was going crazy at first, because GoogleDesktopSearch keeps popping up every time I just hit the CTRL key, and everything I didn't type really-fast has multiple spaces and/or letters that I have to go back and edit out. I tried just disabling Repeat Keys in keyboard preferences, and then realized how much I actually use it. The settings for Delay and Speed seem to be completely ignored.

It at least "seems" like this only manifested itself in the RC version. I don't recall it in the Beta or later Alpha versions (if that helps, at all).

wolfwitch (wolf-mylunarden) wrote :

The "work-around", which admitted does fix the repeating-key problem, also disables any multimedia or related special keys on one's keyboard. So- no unexpectedly repeating keys, but also no volume control, mute, play/pause, or feature keys (like browser/email), which all work without it. Kind of a bad trade-off. It disables all of the "Fn" (Function) keys on my laptop's keyboard as-well.

description: updated

I should note that if you add this flag, restart X, change your keyboard settings, remove the flag, and restart X again, the keyboard settings are maintained (though you have to add the flag again to adjust them again). So at least you can keep the evdev driver and have proper repeat timing. Just can't change it without the flag.

thanks for the comments guys. Hopefully the description is accurate at this point.
and also:
/me crosses fingers and hopes that this bug gets some attention

description: updated
hexion (hexium) wrote :

Same here. This is really annoying.
In my case that workaround does the trick, but as someone reported lots of my keys won't work.

But here, if I remove those lines the issue will happen again no matter what I trie :(

wolfwitch (wolf-mylunarden) wrote :

Per the comments later on- disable AutoAddDevices TEMPORARILY. Adjust the key delay/repeat until it is what is desired, then re-enable AutoAddDevices. It's a PITA if it takes you awhile to tweak your keyboard repeat just-right, but it works. Once you re-enable AutoAddDevices- your multimedia, laptop function, and other special keys should work again (assuming they did to begin with). Also- remember to restart X after each step.

Ryan Steele (rgsteele) wrote :

I find that before using the workaround, setting the keyboard delay slider all the way to the right *does* increase the delay time, but not by as much as it should.

Nolan (kijiki0) wrote :

I have an odd twist on this. For me, it seems like there are two settings.

If I set the delay to minimum, and the speed to max, I get the following behavior:
Immediately repeat is very fast, until the default (unconfigurable) delay time expires, at which point the repeat rate slows down again.

Not sure where the second, unconfigurable delay time and repeat speed settings are coming from.

John Watson (jwatson) wrote :

I noticed the same problem as Nolan. Further, I was able to modify my settings using the System > Preferences > Keyboard GUI until today. I tried changing the repeat rate with kbdrate and then noticed that the settings in the GUI didn't have any effect any more.

I've been tracking down keyboard repeat bugs since Friday. I wonder if this bug might be somehow related? http://bugs.freedesktop.org/show_bug.cgi?id=17925

TheQuickBrownFox (theprash) wrote :

I've got this problem too. Tried using the disable AutoAddDevices temporarily workaround and this fixed the problem but only until I restarted.

I've also noticed, that the delay slider in Keyboard Preferences does have some effect, but it is very slight. Try comparing the lowest setting with the highest. The highest will have a long delay but it's still way too short. I keep typing liiikkkke thisss when I let my guard down.

Sarath (prosarath) wrote :

Quote: "Once changed, you can remove those lines from your xorg.conf (which is recommended since setting AutoAddDevices to off can interfere with your keyboard)"

If i remove the lines and restart X, again the keys ignore the repeat settings.

I found another way of dealing with this. In the same settings Accessibility tab, enable slow keys and set the delay to very less, It will simulate the expected experience

wolfwitch (wolf-mylunarden) wrote :

Well, it seems silly (that we have to resort to this)- but Sarath's solution works very well. Just be sure to set the delay all the way to "short".

wolfwitch (wolf-mylunarden) wrote :

One small annoyance with using the Accessibility work-around, which at this point is less of a problem for me than the insanely repeating keys I'm otherwise experiencing...

For some reason, enabling "slow keys" is disabling the repeat completely on my "down" and "left" arrow keys. It is a trade-off I'm willing to live with for now, but I hope this bug gets fixed soon.

Sarath (prosarath) wrote :

God!

wolfwitch is right. It does take off your clothes on down and left keys. I looked up, it is another bug.
https://bugs.launchpad.net/ubuntu/+source/gnome-settings-daemon/+bug/278078

wolfwitch (wolf-mylunarden) wrote :

I've actually decided, after doing some coding this morning, that it is a trade-off I'm NOT willing to live with.

It's unfortunate that with all the advances Linux has made over the last couple of years, we now have to deal with a stupid flaky keyboard driver. Will my mouse stop working next?

TheQuickBrownFox (theprash) wrote :

Just confirming that I the Slow Keys workaround does the same thing for me too. With it enabled on the lowest setting typing is perfect but there is no repeat on left and down cursor keys.

I agree, wolfwitch, that it is ridiculous that these bugs exist. I hope that when they are fixed the developers don't consider that alone as some kind of triumph. They should instead examine how it was possible for the bugs to appear and get through to a final release and how that can be avoided in the future. Not to be too harsh, though. Intrepid was an excellent release for me in general but for Ubuntu to compete in the mainstream as it wishes to do it cannot afford for too many glitches of sort to appear and remain unsolved for more than a few weeks.

Jorge Morais (jorgemorais) wrote :

I am also affected by this bug. I have installed Ubuntu 8.10 through the alternate CD, and afterwards installed Xubuntu-desktop. The keyboard repeat delay was too short, and I could not change it with the Xfce GUI, the Gnome GUI or with the xset command. Interestingly, typing xset q does reflect the changes made with either the GUI or with the xset r rate command, but the actual keyboard behavior is *not* affected.
I have yesterday installed Kubuntu 8.10 (through the final release alternate CD) in a friend's computer, and updated it shortly after install. Same problem there.

However, I the command kbdrate *does* work in my computer. After I type sudo kbdrate -r 25 -d 500 in an rxvt, the keyboard starts to behave (have not tested yet if the fix lasts after a reboot)

TheQuickBrownFox (theprash) wrote :

I thought I would give a xset a try but I don't understand the syntax. When I type xset this is how it tells me to use the parameter:

r rate [delay [rate]]

So what are you actually supposed to type to set a delay and a rate?

Jorge Morais (jorgemorais) wrote :

>I thought I would give a xset a try but I don't understand the syntax.

I think it is clear enough in the man page. The xset manpage has two paragraphs for the "r" option. The second paragraph says

If the server supports the XFree86-Misc extension, or the XKB
extension, then a parameter of ’rate’ is accepted and should be
followed by zero, one or two numeric values. The first specifies
the delay before autorepeat starts and the second specifies
the repeat rate. In the case that the server supports the XKB extension,
the delay is the number of milliseconds before autorepeat starts,
and the rate is the number of repeats per second. If the rate or delay is not given,
it will be set to the default value.

So if you want a reasonable delay of 500ms a a repeat rate of 25 characters per second, you would type
xset r rate 500 25
Typing xset q (which shows the parameters in effect) then reflects the change. I does *not*, however, make an actual difference in keyboard behavior (which is probably due to this very bug).

My workaround for this problem is adding the line
kbdrate -r 25 -d 500
to the file /etc/rc.local
This fixed the problem for me, with no visible side effects so far.

wolfwitch (wolf-mylunarden) wrote :

Thank you @Jorge Peixoto de Morais Neto!

That is the best work-around so-far. It was getting to be almost impossible to work effectively because of this bug, and now I can. My keyboard acts exactly as I expect it to now, without repeating characters/spaces, and I can use my arrow keys (another bug discussed earlier).

Jorge Morais (jorgemorais) wrote :

(In reply to the immediately previous comment, https://bugs.launchpad.net/ubuntu/+source/xserver-xorg-input-evdev/+bug/264196/comments/27)
You are welcome. I welcome everyone else to test this workaround, and, if you all like it better than the one involving editing xorg.conf, someone could add it to the topmost (first) post of this bug report, to help people with the same problem who browse this page (assuming it is possible to edit an already-submitted post).
And the importance of this bug should be changed from "undecided" to at least "medium" or the like (I don't know what are the selectable values), as it makes the computer use quite annoying, and I imagine would be a show-stopper for disabled people with poor hand dexterity.

description: updated
description: updated
description: updated
Sarath (prosarath) wrote :

Great find! Jorge Peixoto de Morais Neto. I am setting this too. First impression: Awesome. Will post anything abnormal IF found.

Thanks again,
Sarath.

TheQuickBrownFox (theprash) wrote :

Okay, so I've discovered that on my laptop the in-built keyboard and the USB keyboard are behaving differently. Initially they both had the small delay problem. The xset command affects them both in the same way as the keyboard options dialog (i.e. only slightly and with the delay too small). However, the kbdrate command successfully increases the delay on the laptop keyboard but does not affect my USB keyboard.

Furthermore, if I do: "kbdrate -r 2 -d 500" then the laptop keyboard behaves as expected and has a very slow repeat rate. But if I do "kbdrate -r 2 -d 1000" and hold down a key I get a fast repeat for a second or so and then it becomes as slow as it should be. Again, kbdrate does not affect my USB keyboard.

I hope these observations help someone find the root of the problem.

I'm the author of the bug #278078 post. Reading this current bug description & comments, I can see that both bugreports seems to be closely related.

Unfortunately, I haven't got luck with the upstream developers since I opened the bugreport in freedesktop on 2008-10-06:

https://bugs.freedesktop.org/show_bug.cgi?id=17925

The "xset r rate 500 25" workaround serves as a method to ease the reproduction of the "left, down & end keys" issue.

*** Bug 17925 has been marked as a duplicate of this bug. ***

I come from the duplicated bug 17925. My main issue is about the left, down & end keys:

When I press & hold the "down-arrow" key, the "left-arrow" key or the "End"
key, the delay (until the key starts to repeat) is longer than the other keys in the keyboard. I need to hold these keys pressed more time in order to
get repetition.

The issue, however, don't appear when you use the down-arrow key in the keypad
(the "2" key), the left-arrow in the keypad (the "4" key) or the "End" key in
the keypad (the "1" key).

More info is at https://bugs.freedesktop.org/show_bug.cgi?id=17925 .

(In reply to comment #2)

For me the arrow keys start working like other keys after running "xset r 113; xset r 116; xset r 2".

I suggest to open a bugreport in upstream's X.Org freedesktop bug tracker, as I did for the (related) bug #278078.

this is only compile-tested, not run-tested at all, but reasonably obvious, so:
http://people.freedesktop.org/~daniels/evdev-key-repeat.diff

(should probably look better than it does, but hey, i got up at 7am today.)

This patch indeed makes autorepeat work nicely, but for some reason either due to this patch or due to using the master branch of evdev (patch doesn't apply to 2.0.7 and I'm just about to go to bed so not enough time to test without the patch) ctrl-C seems to either crash or just restart the X server, not sure which, all I can see is that I get to log in again. Will try to investigate tomorrow.

Thank you,

So what happens seems to be that the key presses are sent to both X and console, so when I ctrl-C it interrupts the server and when I alt-F4 it closes a window in X but also switches to the fourth VT. But it looks like it happens even without this patch.

Manni (ubuntu-lxxi) wrote :

I cannot offer any workarounds, but I would like to say that my problem is not that my keyboard is now too fast, but that it's way too slow for my taste. Thus the problem is that people are unable to set repeat rate and delay in either direction.

Changed in xorg-server:
status: Unknown → Fix Released
Changed in xorg-server:
status: Fix Released → Unknown
Changed in xorg-server:
status: Unknown → Confirmed
42 comments hidden view all 122 comments

I can't say why it works for me and not you -- it does work for me. kbdrate
is picky about arguments. Try "man kbdrate." I've no more insight on this
issue.

Have a nice day -- George
____________
George Fragos
<email address hidden>
http://FragosTech.com
73 East Swift Ave.
Fresno CA 93704

On Mon, Mar 16, 2009 at 7:30 PM, Rich Wales <email address hidden> wrote:

> I wasn't talking about trying to use the command to display current
> values. When I said "this 'kbdrate' command", I was referring
> generically to the command (with an appropriate, but unspecified
> argument list). And I'm not sure why "kbdrate -r 4 -d 750" works for
> you, because (as I said) it's not working for me.
>
> --
> [intrepid] keyboard Repeat Keys is failing to adjust
> https://bugs.launchpad.net/bugs/264196
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Rich Wales (richw) wrote :

And for reasons I can't explain, when I tried "kbdrate -r 4 -d 750" again just now, it WORKED.

No idea why it worked this time, but not earlier.

Gumby (gumbygum) wrote :

George, I entered your code in the terminal (with a change in the delay rate more to my tastes) and got this output:

sudo kbdrate -r 15 -d 750
[sudo] password for gumby:
Typematic Rate set to 15.0 cps (delay = 750 ms)

And I can report that the internal keyboard in my laptop now responds correctly, but the external USB keyboard I use most of the time does not. It still displays the old repeating key behavior.

Is there any workaround that works for a USB keyboard attached to a laptop?

Rich Wales (richw) wrote :

And everyone should note that this issue also applies to desktops, since most keyboards nowadays use USB (and may or may not come with one of those purple USB-to-PS/2 keyboard adapters). Once I read here that the problem was specifically affecting USB keyboards, I knew enough to try using the PS/2 jack (and I happened to have one of those old adapters lying around!) -- but we cannot expect the average, inexperienced user to have either the knowhow or the wherewithal to do this.

wolfwitch (wolf-mylunarden) wrote :

The workaround posted near the top of this bug, submitted by Jorge Peixoto de Morais Neto, seems to be the best fix for this for now. It works on my laptops and home desktop when using any keyboard...

Just add:

kbdrate -r 25 -d 500

...to /etc/rc.local

I just put it right above "exit 0" at the bottom of the file.

Frankly, I can't believe this hasn't been fixed yet.

Gumby (gumbygum) wrote :

Rich,

I should also point out that my new laptop, (like most of the ones i looked at when i was shopping around), doesn't even HAVE a PS/2 port!

Gumby (gumbygum) wrote :

wolfwitch,

Okay, I edited rc.local, saved the change, and my USB keyboard still has the same problem. Do you have to restart maybe?

Rich Wales (richw) wrote :

Gumby, the builtin keyboard on a laptop is hooked up (internally) to the computer the same way as an external PS/2-style keyboard would be. This explains why the workaround (with a "kbdrate" command) fixes your laptop's internal keyboard.

Wolfwitch, when you say that the "kbdrate" workaround works for you "when using any keyboard", are you trying this with both PS/2 and USB keyboards? If this workaround fixes a USB keyboard, I think that's news.

And I'm having a hard time, too, accepting that this bug is too hard to fix quickly.

wolfwitch (wolf-mylunarden) wrote :

@Gumby- Yes, you would need to restart. The file rc.local runs when your computer boots up (just before Gnome loads). The one "problem" with this fix is it briefly displays the terminal screen just before gdm loads, which isn't nice visually, but it at least makes the computer usable.

@Rich Wales- Sorry, yes- I mean USB keyboards. I can't even remember the last time I used a PS/2 one. I had the key repeat problem on a total of four machines- 3 laptops and 1 desktop (mix of home and work) with USB keyboards. This fixed the problem on all of them.

Gumby (gumbygum) wrote :

I can confirm that wolfwitch is correct. This morning, after restart, my USB keyboard is working properly. :o)

Glauco (glauco-hass) wrote :

I confirm both, the bug and the fix with kbdrate in rc.local, tested in my laptop and desktop, this one with a usb keyboard.
Intrepid with latest updates.

George Fragos (fragos) wrote :

kbdrate works with my USB keyboard adapted to PS/2 but not when placed in
rc.local.

Have a nice day -- George
____________
George Fragos
<email address hidden>
http://FragosTech.com
73 East Swift Ave.
Fresno CA 93704

On Wed, Mar 18, 2009 at 4:31 PM, Glauco <email address hidden> wrote:

> I confirm both, the bug and the fix with kbdrate in rc.local, tested in my
> laptop and desktop, this one with a usb keyboard.
> Intrepid with latest updates.
>
> --
> [intrepid] keyboard Repeat Keys is failing to adjust
> https://bugs.launchpad.net/bugs/264196
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Jeffrey Knockel (jeff250) wrote :

Hi, I've put a patched version of xserver-xorg-input-evdev into my ppa using the patch that Ricardo Pérez López linked to. My ppa is here:
https://launchpad.net/~jeff250/+archive/ppa

It seems to have fixed the problem for me. If this works for others, and there are no side effects, perhaps we could coerce an Ubuntu dev to include the patch in the jaunty release.

Note that if you want to test it, first undo any previous workaround that you may have use before, and then reboot to make sure that the problem comes back. Then install the new package (version 2.1.1-1ubuntu4~ppa1.1) from my ppa and reboot again (or just restart X if you are comfortable doing this). Then play around with the keyboard rate settings and see if they work. Also note any problems that you might have with the new package that you didn't have before.

Daniel Hollocher (chogydan) wrote :

that package fixes it for me. I'm able to change my repeat rates! Yay! Thanks Jeff250.

Anyway, I'm the original bug reporter, and I consider this proof positive that this bug is resolved upstream, and we may be able to get it resolved downstream. ( I kinda wish I knew the details of patching and packaging. Wish I could have done this myself.)

Anyway, here's how I see it. Im the original bug reporter. Im gona open a new bug dedicated to this fix, and getting it backported to jaunty.

If this fix does not work for you, please say so, and open a new bug. Otherwise, if everything goes well, I will close out this bug.

Daniel Hollocher (chogydan) wrote :

@danielhollocher:

Can you test if the key repeat delay of the Left, Down and End keys works well?

(As was reported on bug #278078.)

Daniel Hollocher (chogydan) wrote :

Ricardo:
I've never had that problem. Sorry.

Changed in xorg-server:
status: Confirmed → Unknown
Daniel Hollocher (chogydan) wrote :

Actually, I do have that problem on intrepid. I never tested on jaunty. Testing now on jaunty with the evdev from the archive, I don't have the problem. I will downgrade, and see if I did have that problem on jaunty.

Changed in xorg-server:
status: Unknown → Fix Released
Rich Wales (richw) wrote :

Jeff, will your patch work on intrepid? I would really like a fix to this problem ASAP, but I depend on my machine being stable and really can't upgrade to jaunty while it's still pre-release.

Jeffrey Knockel (jeff250) wrote :

It seems to work just as well in intrepid. I've now uploaded intrepid packages to the ppa. Just make sure you use intrepid on the deb/deb-src lines, not jaunty.

Rich Wales (richw) wrote :

Thanks. I installed the patch in intrepid just now. It seems to work fine, EXCEPT that the "left" and "down" arrow keys do not repeat AT ALL (no matter how long I hold them down).

Jeffrey Knockel (jeff250) wrote :

I just tested that, and I can confirm the same regression on intrepid. Since you, Daniel Hollocher, and I can confirm the left/down arrow regression on intrepid when we use the patched evdev packages, we should probably let go of intrepid and focus on jaunty, since both Daniel and I cannot reproduce this regression on jaunty when using the patched evdev packages.

I believe that the left/down regression was fixed somewhere in between intrepid and jaunty's xserver, since, when I cherry-picked the latest jaunty xserver packages onto my intrepid box, the regression was not present, even when using my patched evdev package. (Note that cherry picking packages, in general, is a risky idea in terms of overall stability, and I've since reverted the xserver packages on my intrepid box to the intrepid versions, but doing it can be useful for experiments like this.)

I will leave the intrepid evdev packages in my ppa anyways, in case someone wants to still play around with them, but I don't advise using them, and it's too late for any fix like this to appear in intrepid anyways, whereas at least the chance for this fix to appear in jaunty is nonzero. And since jaunty thus far has *not* been shown to be affected by the left/down arrow regression, this is why we still need more testers for the ppa package in jaunty.

As an aside, I also tested evdev-2.2.0 (a much newer version of the evdev in jaunty) on my jaunty box. I won't put it in my ppa, but it automatically reflects the patch for the repeat bug that I used to patch the package in my ppa archive. Like we would expect, I also tested it to solve repeat bug. So, if we cannot patch jaunty's evdev package to include the fix, the good news is that the first ubuntu version (likely jaunty+1) to use evdev-2.2.0 or greater will get this fix for free.

Rich Wales (richw) wrote :

OK, understood. Could you remind me (and others) how to safely uninstall your patched package and revert to the regular version of same?

Jeffrey Knockel (jeff250) wrote :

Yes, here's the GUI instructions:
Select the package in synaptic
In menu, go to Package -> Force version...
Then select the version you want to downgrade to.
Apply this downgrade, restart X or your computer, and you should be back to using intrepid's version.

Reuben Thomas (rrt) wrote :

Would it be possible to keep further discussion to the forums? This bug report is already unhelpfully long, and it's hard to extract the useful information, namely: what is the bug? where is it present? when is it likely to be fixed? how can I work around it? All of these questions are now answered, but some of the remarks about evdev and the arrow keys in the preceding few comments show that at least some users have not managed to find at least some of this information. Example: an announcement of a patched evdev package is useful; discussion of how to install and uninstall it do not belong here.

Having said that, maybe the Ubuntu devs could take note: long threads such as this one in the BTS often reflect bugs that are inconveniencing many users, and quite how they imagine that having unconfigurable keyboard autorepeat two releases in a row[1] is anything approaching acceptable, I do not understand.

[1]Hacks and workarounds don't count. I am talking about the standard configuration mechanism that is all that 99% of users will ever try.

Jeffrey Knockel (jeff250) wrote :

The bug for inclusion of the patch into jaunty is bug 345397. It also has summarized mostly what you're looking for, including steps to reproduce, a theory of the problem, and a patch that you can test. Future discussion of one's experience with the jaunty patch should go there.

Other discussion, including how to install the jaunty patch, and so on can go here:
http://ubuntuforums.org/showthread.php?t=1101190

Steve Grace (sgrace) wrote :

I had this issue as well with a USB keyboard. It drove me nuts until I found out it was a bug; this really should have a higher priority than it's been given.

The kbdrate fix didn't work for me. The xorg.conf fix worked but only if I kept the changes in; I couldn't enable them temporarily and then disable them as some posters could.

I opted for enabling Slow Keys (per Sarath in message #18) plus running a startup script containing the three xset commands (listed by Ricardo Perez Lopez in message #41).

FYI: I've workaround this bug upgrading to Jaunty. Jaunty seems to resolve it, or, at least, I haven't the Left, Down and End keys issue, and all seems OK.

Toby (tobygrunt) wrote :

Two Outstanding Issues ?

1) Did anyone else have the problem that the fixes did not work for a non-admin account? (even when permissions temporarily changed to admin to apply the fixes). The only solution was to create a new user account, for which the fixes already applied worked fine. (i.e. they were in place as soon as the account was created)

2) The problem occurred on a desktop with a wireless multimedia keyboard with PS/2 connector (earlier posts suggested it only affected USB keyboards and PS/2 would fix).

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package xserver-xorg-input-evdev - 1:2.1.1-1ubuntu4

---------------
xserver-xorg-input-evdev (1:2.1.1-1ubuntu4) jaunty; urgency=low

  [Bryce Harrington]
  * rules: Adding 'patch' to the build task appears to be unnecessary.

  [Jeffrey Knockel]
  * Add 102_filter_kernel_repeat.patch: Allow software to control keyboard
    repeat rate. (LP: #345397, LP: #264196)

 -- Bryce Harrington <email address hidden> Fri, 03 Apr 2009 17:45:01 -0700

Changed in xserver-xorg-input-evdev (Ubuntu):
status: Confirmed → Fix Released
Gumby (gumbygum) wrote :

The bug is back. The edit in rc.local fixed it for 2-1/2 weeks, but
today the old fast-repeat misbehavior has returned on my USB keyboard,
but not on the laptop's built-in keyboard.

I checked rc.local and my fix is still there, has not disappeared.

I am using Mint 6.0

On 4/4/09, Launchpad Bug Tracker <email address hidden> wrote:
> This bug was fixed in the package xserver-xorg-input-evdev -
> 1:2.1.1-1ubuntu4
>
> ---------------
> xserver-xorg-input-evdev (1:2.1.1-1ubuntu4) jaunty; urgency=low
>
> [Bryce Harrington]
> * rules: Adding 'patch' to the build task appears to be unnecessary.
>
> [Jeffrey Knockel]
> * Add 102_filter_kernel_repeat.patch: Allow software to control keyboard
> repeat rate. (LP: #345397, LP: #264196)
>
> -- Bryce Harrington <email address hidden> Fri, 03 Apr 2009 17:45:01
> -0700
>
> ** Changed in: xserver-xorg-input-evdev (Ubuntu)
> Status: Confirmed => Fix Released
>
> --
> [intrepid] keyboard Repeat Keys is failing to adjust
> https://bugs.launchpad.net/bugs/264196
> You received this bug notification because you are a direct subscriber
> of the bug.
>
> Status in X.Org X server: Fix Released
> Status in “xserver-xorg-input-evdev” source package in Ubuntu: Fix Released
>
> Bug description:
> go to System > Preferences > Keyboard > General
>
> The controls under Repeat Keys are failing to properly adjust the timing of
> how fast keys are repeated when held down.
>
> I filed under gnome, but a person there thinks its an xorg bug in ubuntu:
> http://bugzilla.gnome.org show_bug.cgi?id=550242 It has become quite
> clear that this is a problem with the xorg-evdev driver, and intrepids new
> hotplug architecture.
>
>
> Here is a workaround for this:
>
> Temporarily add the following to your xorg.conf:
> Section "ServerFlags"
> Option "AutoAddDevices" "off"
> EndSection
>
> Restart X, and you will be able to change the settings. Once changed, you
> can remove those lines from your xorg.conf (which is recommended since
> setting AutoAddDevices to off can interfere with your keyboard)
>
>
> Another (and possibly better) workaround is to set the repeat rate manually,
> see this comment for directions:
> https://bugs.launchpad.net/ubuntu/+source/xserver-xorg-input-evdev/+bug/264196/comments/26
>
>
> This bug may also be related to bug 278078
>

Gumby (gumbygum) wrote :

Okay, um...today the USB keyboard is working fine again. I didn't change anything. Never mind!

Daniel Hollocher (chogydan) wrote :

thanks to everyone. I am very glad to have this bug fixed. Time for one last edit...

description: updated
Thane (byd) wrote :

Not fixed yet! I'm using Ubuntu 8.10 amd 64 Desktop and I've still got the problem unfortunately. Saw the reference to xserver-xorg-input-evdev - 1:2.1.1-1ubuntu4 , but I cannot get it through either enabling Ubuntu backports or proposed repositories either since its not available through the other standard repos. I had success for about a week to a week and a half using the rc.local fix. But Ubuntu took this away from me (in updates I think). I've also tried the xorg.conf server flags workaround, but it was shortlived. Semi-worked but then gave up the ghost. Now I'm back to square one with no control over my keyboard repeat rate.

Reuben Thomas (rrt) wrote :

Please stop this noise. The bug IS fixed IN JAUNTY AND KARMIC, as the updated description clearly says, and not in Intrepid.

Daniel Hollocher (chogydan) wrote :

@Thane
Yep, no fix for 8.10. You will get it with 9.04 at the end of this month. (If you really need the fix now, you can upgrade to the 9.04 beta with the command `update-manager -d`. But, that has the drawback that its still beta, and still has bugs in it)

Good luck.

Rich Wales (richw) wrote :

Intending no disrespect here to the developers, I am less than happy about the apparent decision not to try to fix this bug in Intrepid. It was my understanding that Intrepid was supposed to be supported for another year. Also, the conflicting reports regarding the nature and extent of this bug -- people saying the bug appears and goes away for no apparent reason, people disagreeing on whether fixes work for them or not, etc. -- suggest to me that the problem still might not be fully understood, and that this isn't a good time to abandon groups of users yet.

Daniel Hollocher (chogydan) wrote :

@Rich Wales: yes, Intrepid is supported awhile longer, but only for bugs that cause data loss or security issues.

@Reuben Thomas: hit unsubscribe. /me reaches for the unsubscribe button himself.

Reuben Thomas (rrt) wrote :

The bug is fully understood and fully fixed, but it's quite complicated, as it involves multiple components, specifically, the interaction between X and kernel auto-repeat. That's also why the suggested workarounds are quite different, and, presumably, why the devs are not keen to backport the fix to Intrepid, though personally I think putting out a distro in which 99% of users will conclude that autorepeat is broken is very unfortunate, and not fixing it is really dumb from a PR perspective, if nothing else. But maybe it doesn't register in the big picture.

Gumby (gumbygum) wrote :

First of all, I have not been able to reach the website for this bug,
https://bugs.launchpad.net/ubuntu/+source/xserver-xorg-input-evdev/+bug/264196,
in over a week.

I must point out that this bug is now happening approximately half the time
I start a Linux session. It's happening again today. This is despite the
fix. So, sometimes the fix works, and sometimes it does not, on the same
compuuter. It's driving me crazy even as I type this message. I'vvve already
corrected a bunch of the repeat types.

Changed in xorg-server:
importance: Unknown → Medium
Changed in xorg-server:
importance: Medium → Unknown
Changed in xorg-server:
importance: Unknown → Medium
Displaying first 40 and last 40 comments. View all 122 comments or add a comment.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.